"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _nukaCarousel = _interopRequireDefault(require("nuka-carousel"));

var _reactImages = _interopRequireDefault(require("react-images"));

var _Background = _interopRequireDefault(require("../Background"));

var _Image = _interopRequireDefault(require("../Image"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _cloudinary = require("../Image/cloudinary");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var decorators = [{
  component: function component() {
    return null;
  },
  position: 'BottomCenter',
  style: {
    padding: 20
  }
}, {
  component: function component(_ref) {
    var previousSlide = _ref.previousSlide;
    return _react.default.createElement(_Icon.default, {
      className: "pa2 bg-black-30 white pointer",
      onClick: previousSlide,
      icon: "fa-angle-left"
    });
  },
  position: 'CenterLeft',
  style: {
    padding: 20
  }
}, {
  component: function component(_ref2) {
    var nextSlide = _ref2.nextSlide;
    return _react.default.createElement(_Icon.default, {
      className: "pa2 bg-black-30 white pointer",
      onClick: nextSlide,
      icon: "fa-angle-right"
    });
  },
  position: 'CenterRight',
  style: {
    padding: 20
  }
}];

var ProductSlider =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ProductSlider, _React$PureComponent);

  function ProductSlider() {
    var _ref3;

    var _temp, _this;

    _classCallCheck(this, ProductSlider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_ref3 = ProductSlider.__proto__ || Object.getPrototypeOf(ProductSlider)).call.apply(_ref3, [this].concat(args))), Object.defineProperty(_assertThisInitialized(_this), "state", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {}
    }), Object.defineProperty(_assertThisInitialized(_this), "onSelect", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(e, selected) {
        e.preventDefault();

        _this.ref.goToSlide(selected);
      }
    }), _temp));
  }

  _createClass(ProductSlider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.timeout = setTimeout(function () {
        _this2.ref.setDimensions();
      }, 0);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timeout);
    } // afterSlide = console.log

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var images = this.props.images;
      var _state = this.state,
          opened = _state.opened,
          selected = _state.selected;
      var galleryItems = images.map(function (image) {
        return {
          src: (0, _cloudinary.imageFromId)(image),
          srcset: (0, _cloudinary.makeSrcset)(image).map(function (_ref4) {
            var src = _ref4.src,
                size = _ref4.size;
            return "".concat(src, " ").concat(size, "w");
          })
        };
      }); // const { selected = images[0] } = this.state

      return _react.default.createElement("div", null, _react.default.createElement(_nukaCarousel.default, {
        decorators: decorators,
        ref: function ref(_ref5) {
          _this3.ref = _ref5;
        } // afterSlide={this.afterSlide}

      }, images.map(function (image, idx) {
        return _react.default.createElement("div", null, _react.default.createElement(_Background.default, {
          key: idx,
          image: image,
          className: "aspect-ratio--1x1 cover bg-center pointer" // alt={x.title}
          ,
          onLoad: function onLoad() {
            window.dispatchEvent(new Event('resize'));
          }
        }));
      })), _react.default.createElement(_nukaCarousel.default, {
        decorators: decorators,
        ref: function ref(_ref6) {
          _this3.ref = _ref6;
        },
        slidesToShow: 2.5 // afterSlide={this.afterSlide}

      }, images.map(function (image, idx) {
        return _react.default.createElement("div", null, _react.default.createElement(_Background.default, {
          key: idx,
          image: image,
          className: "aspect-ratio--1x1 cover bg-center pointer" // alt={x.title}
          ,
          onLoad: function onLoad() {
            window.dispatchEvent(new Event('resize'));
          }
        }, _react.default.createElement(_Icon.default, {
          icon: "fa-expand"
        })));
      })), _react.default.createElement(_reactImages.default, {
        currentImage: selected,
        images: galleryItems,
        isOpen: opened,
        showThumbnails: true,
        onClickThumbnail: function onClickThumbnail(value) {
          _this3.setState({
            selected: value
          });
        },
        onClickPrev: function onClickPrev() {
          _this3.setState({
            selected: selected - 1 < 0 ? selected : selected - 1
          });
        },
        onClickNext: function onClickNext() {
          _this3.setState({
            selected: selected + 1 >= images.length ? 0 : selected + 1
          });
        },
        onClose: function onClose() {
          return _this3.setState({
            opened: false
          });
        }
      }), _react.default.createElement("div", {
        className: "w-100 flex overflow-x-auto"
      }, images.map(function (image, idx) {
        return _react.default.createElement("div", {
          key: idx,
          className: "pa2 flex-none"
        }, _react.default.createElement(_Image.default // eslint-disable-line
        , {
          className: "w3 h3 pointer",
          image: image,
          onClick: function onClick(e) {
            return _this3.onSelect(e, idx);
          }
        }));
      })));
    }
  }]);

  return ProductSlider;
}(_react.default.PureComponent);

exports.default = ProductSlider;